Subject: [Technical Errata Reported] RFC5952 (2656)

From: RFC Errata System <[email-masked]>
Date: Thu, 2 Dec 2010 13:17:50 -0800 (PST)

The following errata report has been submitted for RFC5952,
"A Recommendation for IPv6 Address Text Representation".

--------------------------------------
You may review the report below and at:
http://www.rfc-editor.org/errata_search.php?rfc=5952&eid=2656

--------------------------------------
Type: Technical
Reported by: D. Stussy <[email-masked]>

Section: 4.3

Original Text
-------------
4.3.  Lowercase

   The characters "a", "b", "c", "d", "e", and "f" in an IPv6 address
   MUST be represented in lowercase.

Corrected Text
--------------
4.3.  Case of Alphabetic Digits.

   The digits "A" through "F" in an IPv6 address
   MUST be represented in upper case.  User and user
   derived input may be represented using lower case.

Notes
-----
Historically from the 1960's, hexidecimal digits other than decimal digits are represented by upper case letters.  Lower case letters may have become acceptable as user input, but such resulted from lazy programmers who couldn't manage to hit the shift key on their keyboards.  However, lower case is not acceptable for digit output.  Many early assemblers would not even accept lower case as valid input digits except where the radix base exceeded 36 (thus exhausting all upper case values).  This poor programming practice should not be allowed to be codified into any Internet standard.

References:
- Struble, George W., "Assembler Language Programming:  The IBM System/360 and /370."  Addison-Wesley Publishing Co., 1969 and 1975 (Second Edition), Page 6.  ISBN 0-201-7322-6
- Barden, William Jr., "TRS-80 Assembly-Language Programming."  Tandy Corporation, 1979, page 14.  Library of Congress #79-63607 
- Leventhal, Lance A., "6502 Assembly Language Programming." Osborne McGraw-Hill, 1979 and 1986 (Second Edition), Page 1-4.  ISBN 0-07-881216-X
- Intel Corporation, "Intel486 Microprocessor Family Programmer's Reference Manual."  1995, Page 1-8 (Section 1.3.4).  No ISBN or LoC #.
- Cress, Paul, Dirksen, Paul, and Grahm, J. Wesley, "Fortran IV with WatFor and WatFiv."  Prentice-Hall, 1968 and 1970, Page 245.  LoC 74-129241
- Mano, M. Morris, "Computer System Architecture."  Prentice-Hall, 1982, Page 79.  ISBN 0-13-166611-8
- Higgins, Richard J., "Electronics with Digital and Analog Integrated Circuits."  Prentice-Hall, 1983, Page 60.  ISBN 0-13-250704-8

However, I also note this ONE source permits mixed case:
- Kernighan, Brian W. & Ritchie, Dennis M., "The C Programming Language", Prentice Hall, 1978 (First Edition), Page 180.  ISBN 0-13-110163-3

Many other pre-1990 computer science and engineering books show hexidecimal non-decimal digits as upper case only and NEVER as lower case.  However, I could not find pages in them defining the lettered-digits as upper case only despite their consistent usage of upper case printing.

Instructions:
-------------
This errata is currently posted as "Reported". If necessary, please
use "Reply All" to discuss whether it should be verified or
rejected. When a decision is reached, the verifying party (IESG)
can log in to change the status and edit the report, if necessary. 

--------------------------------------
RFC5952 (draft-ietf-6man-text-addr-representation-07)
--------------------------------------
Title               : A Recommendation for IPv6 Address Text Representation
Publication Date    : August 2010
Author(s)           : S. Kawamura, M. Kawashima
Category            : PROPOSED STANDARD
Source              : IPv6 Maintenance
Area                : Internet
Stream              : IETF
Verifying Party     : IESG

---

From: Jeroen Massar <[email-masked]>
Date: Thu, 02 Dec 2010 22:37:37 +0100

On 2010-12-02 22:17, RFC Errata System wrote:
> 
> The following errata report has been submitted for RFC5952, "A
> Recommendation for IPv6 Address Text Representation".
[..]
> Historically from the 1960's, hexidecimal digits other than decimal
> digits are represented by upper case letters.  Lower case letters may
> have become acceptable as user input, but such resulted from lazy
> programmers who couldn't manage to hit the shift key on their
> keyboards.

Welcome to 2010!

I also want to state that I find the above text absolutely insulting to
any programmer on this planet and even in galaxies far far away.

> However, lower case is not acceptable for digit output.
> Many early assemblers would not even accept lower case as valid input
> digits except where the radix base exceeded 36 (thus exhausting all
> upper case values).  This poor programming practice should not be
> allowed to be codified into any Internet standard.

There is nothing 'poor' about outputting lower case characters which are
in the same optical spectrum as the numeric values of hex.

I really do not support any such change and I sincerely hope that the
RFC Editor removes this ad hominem attack to all programmers.

Greets,
 Jeroen

---

From: Cutler James R <[email-masked]>
Date: Thu, 2 Dec 2010 16:45:49 -0500

Although the comments about "lazy" are specious, I support requiring uppercase display simply from the viewpoint of easy recognition by those of us with less-than-perfect visual acuity. There probably is no other strong reason except apparent consistency of display which, in itself, is a good thing.

On Dec 2, 2010, at 4:17 PM, RFC Errata System wrote:

> <SNIP/>
> --------------------------------------------------------------------

Although the comments about "lazy" are specious, I support requiring uppercase display simply from the viewpoint of easy recognition by those of us with less-than-perfect visual acuity. 

There probably is no other strong reason for requiring either case except apparent consistency of display which, in itself, is a good thing.

James R. Cutler
[email-masked]

---

From: Brian E Carpenter <[email-masked]>
Date: Fri, 03 Dec 2010 11:33:04 +1300

There is no way this is an erratum. There was a clear choice in the WG
to standardise on lower case.

There could be no objection to a presentation-layer choice to display upper
case in a GUI as a matter of user preference. However, I was surprised by
the suggestion that upper case is better for people with limited visual
acuity. My eyes are well past their use-by date and I haven't found this
to be an issue. There is evidence for upper case being better *for a
given font size*:
http://www.ncbi.nlm.nih.gov/pmc/articles/PMC2016788/
Therefore, another GUI option could be to use a bigger font size.

In any case I would object to this erratum being accepted.

Regards
   Brian Carpenter

P.S.

> Many other pre-1990 computer science and engineering books show hexidecimal non-decimal digits as upper case only

I would like to report an erratum in that sentence: s/hexidecimal/hexadecimal/

More seriously, many computers in the early days only knew how to print
upper case; hence there was a strong bias against lower case in both software
and documentation. It's no surprise that the ancient scrolls use upper case.
However, I have a copy of "Electronic Digital Computers" by Charles V.L Smith
(of the Aberdeen Proving Ground), published in 1959 by McGraw-Hill, which
on page 4 refers to "sexadecimal" notation (you gotta love that) in which
"the first six lower-case letters of the alphabet a, b, c, d, e, and f,
may conveniently be used." I think that trumps the references below in
terms of age.

On 2010-12-03 10:17, RFC Errata System wrote:
> IETF IPv6 working group mailing list
> [email-masked]
> Administrative Requests: https://www.ietf.org/mailman/listinfo/ipv6

---

From: "Manfredi, Albert E" <[email-masked]>
Date: Thu, 2 Dec 2010 16:38:58 -0600

> to standardise on lower case.

Glad to hear this. I reacted very much like Jeroen Massar. "That's SO last century!"

(Although I did check to see what ipconfig does in Windows. Upper case!)

Bert

---

From: Fernando Gont <[email-masked]>
Date: Thu, 02 Dec 2010 21:15:33 -0300

On 02/12/2010 06:45 p.m., Cutler James R wrote:

> Although the comments about "lazy" are specious, I support requiring
> uppercase display simply from the viewpoint of easy recognition by
> those of us with less-than-perfect visual acuity. 

Huh? Increase the font size, get a larger display, etc., etc., etc.

C'mon...

Note: I use both contact lens and glasses at the *same* time, in case
you misinterpret where I'm coming from.

Thanks,
-- 
Fernando Gont
e-mail: [email-masked] || [email-masked]
PGP Fingerprint: 7809 84F5 322E 45C7 F1C9 3945 96EE A9EF D076 FFF1

---

From: Masanobu Kawashima <[email-masked]>
Date: Fri, 3 Dec 2010 09:28:19 +0900

We examined many implementations before proposal.
Many implementations (such as Windows, Linux, FreeBSD,
 and many other network devices) display lower case.

I would like to ask simple question.
Can we change many implementations?
I think that is too late.
lowercase is already "de fact standard".

Best regards,
Masanobu

---

From: [email-masked]
Date: Fri, 03 Dec 2010 07:44:16 +0100 (CET)

> Glad to hear this. I reacted very much like Jeroen Massar. "That's SO last century!"

Agreed. I find lower case much more readable, and the errata should
not be accepted.

Steinar Haug, Nethelp consulting, [email-masked]

---

From: Bob Hinden <[email-masked]>
Date: Fri, 3 Dec 2010 08:07:32 -0800

Brian,

> to standardise on lower case.

I agree.  This was a deliberate decision by the 6man working group, it is not an error.

> In any case I would object to this erratum being accepted.

+1

Bob

---

From: Ed Jankiewicz <[email-masked]>
Date: Fri, 03 Dec 2010 11:45:30 -0500

I concur with support for the decision in RFC 5952 to establish a 
canonical format for IPv6 addresses.  The choice of lower-case was 
deliberate and subject to review and consensus within the working group, 
and should not be construed as an "erratum".  Opinions and  
implementations may vary.  "Harm" in non-conformance is minor, resulting 
in more complex processing of textual output as input to another 
system.  The canonical format was intended to to make such textual 
output from various implementations to be comparable, for merging and 
sorting in reports, etc.  Personally, I would code defensively (liberal 
in what I accept from other systems) while respecting the canonical 
format for my output (conservative in what I do) [RFC793].

On 12/2/2010 4:17 PM, RFC Errata System wrote:
> Reported by: D. Stussy<[email-masked]>
>
> Section: 4.3
>
> Original Text
> -------------
> 4.3.  Lowercase
>
> - Kernighan, Brian W.&  Ritchie, Dennis M., "The C Programming Language", Prentice Hall, 1978 (First Edition), Page 180.  ISBN 0-13-110163-3
>

-- 
Ed Jankiewicz - SRI International
Fort Monmouth Branch Office - IPv6 Research
Supporting DISA Standards Engineering Branch
732-389-1003 or  [email-masked]

---

From: Juergen Schoenwaelder <[email-masked]>
Date: Fri, 3 Dec 2010 23:36:02 +0100

> to standardise on lower case.

[...]
 
> In any case I would object to this erratum being accepted.

I agree that the errata should be rejected - erratas are the wrong
procedure to question working group decisions. That said, let me add
that I support the decision documented in RFC 5952 (and which is also
codified in RFC 6021).

/js

-- 
Juergen Schoenwaelder           Jacobs University Bremen gGmbH
Phone: +49 421 200 3587         Campus Ring 1, 28759 Bremen, Germany
Fax:   +49 421 200 3103         <http://www.jacobs-university.de/>

---

From: Seiichi Kawamura <[email-masked]>
Date: Mon, 06 Dec 2010 10:30:31 +0900

> I agree.  This was a deliberate decision by the 6man working group, it is not an error.

Don't have much further to say,
but I agree with Brian, Bob and others that
this was a decision by the WG and not an error.

Regards,
Seiichi